package com.altimetrik.poc.controller;
import com.altimetrik.poc.dto.Customer;
import com.altimetrik.poc.dto.NewValetAmout;
import com.altimetrik.poc.dto.OrderDetails;
import com.altimetrik.poc.repository.UserLoggedInRepository;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.mock.mockito.MockBean;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.mockito.Mockito.*;
import static org.mockito.Mockito.when;


@SpringBootTest
public class UserDataControllerTest {

    @MockBean
    UserLoggedInRepository userLoggedInRepository;

    @Autowired
    UserDataController userDataController;

    @Test
    public void addProducts(){
        Customer c =  new Customer(1,"Shishir", "Namdeo","shishirnamdeo220@gmaik.com",0);

        userDataController.addUser(c);
        verify(userLoggedInRepository,times(1)).save(c);
    }

    @Test
    public void getUserValetAmount(){
        Customer c =  new Customer(1,"Shishir", "Namdeo","shishirnamdeo220@gmaik.com",0);
        when(userLoggedInRepository.findByReference(Customer.refer)).thenReturn(c);
        assertEquals(0,userDataController.getUserValetAmount());
    }

    @Test
    public void updateValetAmount(){
        Customer c =  new Customer(1,"Shishir", "Namdeo","shishirnamdeo220@gmaik.com",0);
        when(userLoggedInRepository.findByReference(Customer.refer)).thenReturn(c);
        OrderDetails pd = new OrderDetails(300,3721,4356,6456,6565,454, 667,new Integer[43], new Customer());
        userDataController.updateValetAmount(new NewValetAmout("123"));
        verify(userLoggedInRepository,times(1)).save(c);
    }
}

